<template>
  <v-card>
	  <v-card-title>{{card_title}}</v-card-title>
	  <v-card-subtitle></v-card-subtitle>
	  <v-card-text>
		 
		<v-form
			ref="form"
			v-model="valid"
			lazy-validation
		>
			<v-text-field
			v-model="title"
			:counter="200"
			:rules="titleRules"
			label="Title"
			required
			></v-text-field>

			<v-textarea
			v-model="description"
			:counter="1200"
			:rules="descriptionRules"
			label="Description"
			required
			></v-textarea>

			<v-file-input
			accept="image/*"			
			label="Blog Image"
			required
			v-on:change="upload(files,$event)"
			></v-file-input>

			<v-checkbox
			v-model="userValid"
			:rules="[v => !!v || 'You must agree to continue!']"
			label="Are you sure the data is valid?"
			required
			></v-checkbox>

			<v-btn
			:disabled="!valid"
			color="success"
			class="mr-4"
			@click="validate"
			>
			Submit
			</v-btn>

			<v-btn
			color="error"
			class="mr-4"
			@click="reset"
			>
			Reset Form
			</v-btn>

		</v-form>

	  </v-card-text>	  
  </v-card>
</template>

<script>
import alert from '../../components/Alert.vue'
import {mapActions, mapGetters} from 'vuex' 
export default {

	name:'blog-creation',
	data:function(){
		return{
			card_title:'Create Blog Data',
			valid: true,
			title: '',
			titleRules: [
				v => !!v || 'Title is required',
				v => (v && v.length <= 200) || 'Title must be less than 200 characters',
			],
			description: '',
			descriptionRules: [
				v => !!v || 'description is required',
				v => (v && v.length <= 1200) || 'Description must be less than 1200 characters',
			],
			image: null,
			userValid: false,
			files:[]
		}
	},
	methods:{
		validate () {
			let isValidated = this.$refs.form.validate()
			if(isValidated){
				this.submit()
			}
		},
		reset () {
			this.$refs.form.reset()
			this.$refs.form.resetValidation()
		},
		async submit(){
			try {
				
				let response = await axios.post('/api/blog/store',this.getForm(),this.getHeader())

				let {status} = response

				if(status==201){
					
					let {data, response_code, response_message} = response.data

					if(response_code==="00"){
						if(data.title == this.title){

							this.alert({
								title:'success',
								message:`Data Blog dengan judul ${this.title} berhasil disimpan!`
							})
							this.$refs.form.reset()
							this.$router.push({name:'blogs'})
						}
					}

				}else{

					this.alert({
						title:'error',
						message:'Data tidak berhasil disimpan!'
					})

				}

			} catch (err) {
				
				console.log(err)

				let {message} = err.response

				this.alert({
						title:'error',
						message:message,
						theErrors: err.response.data.errors
					})

			}			

		}
		,
		...mapActions({
			alert:'alert/show',
		}),
		getForm:function(){

			let form = new FormData()
			form.append('title',this.title)
			form.append('description',this.description)
			form.append('image',this.image)
			form.append('valid',this.userValid)

			return form

		},getHeader:function(){
			return{
				headers:{
					'Accet': 'application/json',
					'Access-Control-Allow-Headers': 'Authorization',
					'Autentication':`Bearer ${this.token}`
				}
			}
		},
		upload(files,image){
			this.image = image
		}

	},computed:{
		...mapGetters({
			token:'authenticate/haveToken'
		}),
		
	}

}
</script>

<style>

</style>